#!/bin/bash

#this script replaces the backuppc ping command

PING=/bin/ping
argnum=$(($#-1))
ARGS=${@:1:$argnum}
WAKEHOST="${!#}"
ETHWAKE=/usr/bin/wakeonlan
WOLDIR=/usr/tools/wol
SLEEPTIME=4m

echo "Backuppc pinging $ARGS $WAKEHOST"

function getwol {
	if [ -f $WOLDIR/$1.wol ]; then
	   hwaddr=$(cat $WOLDIR/$1.wol | cut -d" " -f4)
	else
	   echo "No MAC address for $1"
	   exit -1
	fi
}

function fwol {
        TO_WAKEUP=$1
	getwol $1 
        sudo $ETHWAKE $hwaddr
}

$PING $ARGS $WAKEHOST >>/dev/null 2>&1

if [ $? -ne 0 ]; then
        fwol $WAKEHOST
        if [ "$WOL_RES" = "FAIL" ]; then
                exit 1
        fi
	sleep 2
	fwol $WAKEHOST
        if [ "$WOL_RES" = "FAIL" ]; then
                exit 1
        fi
	if [ -f $WOLDIR/$WAKEHOST.state ]; then
		echo -n "Previous state preserved: "
		cat $WOLDIR/$WAKEHOST.state
	else
		echo "OFF" > $WOLDIR/$WAKEHOST.state
	fi
        sleep $SLEEPTIME
        $PING $ARGS $WAKEHOST
        if [ $? -eq 0 ]
        then
           echo "success waking $WAKEHOST."
        else
           echo "unable to wake $WAKEHOST."
           exit 1
        fi
else
   $PING $ARGS $WAKEHOST
   if [ -f $WOLDIR/$WAKEHOST.state ]; then
   	echo -n "Previous state preserved: "
	cat $WOLDIR/$WAKEHOST.state
   else
      	echo "ON" > $WOLDIR/$WAKEHOST.state
   fi
fi

exit 0
